function CastTime_Register()
	if (Cosmos_RegisterConfiguration) then
		Cosmos_RegisterConfiguration(
			"COS_CASTTIME",
			"SECTION",
			CASTTIME,
			CASTTIME_INFO
			);
		Cosmos_RegisterConfiguration(
			"COS_CASTTIME_SEP",
			"SEPARATOR",
			CASTTIME,
			CASTTIME_INFO
			);
		Cosmos_RegisterConfiguration(
			"COS_CASSTTIME_DISPLAY_TOGGLE",
			"CHECKBOX",
			CASTTIME_DISPLAY_TOGGLE,
			CASTTIME_DISPLAY_TOGGLE_INFO,
			CastTime_Toggle_display,
			CastTime.display
			);
		Cosmos_RegisterConfiguration(
			"COS_CASTTIME_DELAY_TOGGLE",
			"CHECKBOX",
			CASTTIME_DELAY_TOGGLE,
			CASTTIME_DELAY_TOGGLE_INFO,
			CastTime_Toggle_delay,
			CastTime.delay
			);
		Cosmos_RegisterConfiguration(
			"COS_CASTTIME_HUN_TOGGLE",
			"CHECKBOX",
			CASTTIME_HUN_TOGGLE,
			CASTTIME_HUN_TOGGLE_INFO,
			CastTime_Toggle_hun,
			CastTime.hun
			);
		Cosmos_RegisterConfiguration(
			"COS_CASTTIME_FRAME_LOCK",
			"CHECKBOX",
			CASTTIME_FLOCK_TOGGLE,
			CASTTIME_FLOCK_TOGGLE_INFO,
			CastTime_Toggle_flock,
			CastTime.flock
			);
		Cosmos_RegisterConfiguration(
			"COS_CASTTIME_FRAME_USE",
			"CHECKBOX",
			CASTTIME_MF_TOGGLE,
			CASTTIME_MF_TOGGLE_INFO,
			CastTime_Toggle_mf,
			CastTime.mf
			);
	else
	end
	SlashCmdList["CASTTIME"] = CastTime_SlashHandler;
	SLASH_CASTTIME1 = "/castt";
end

function CastTime_Toggle_display(toggle)
	if (toggle == 0) then
		CastTime.display = 0;
		CastTime_Print(CASTTIME_STATUS_DISPLAY..CASTTIME_OFF);
	else
		CastTime.display = 1;
		CastTime_Print(CASTTIME_STATUS_DISPLAY..CASTTIME_ON);
	end
end

function CastTime_Toggle_delay(toggle)
	if (toggle == 0) then
		CastTime.delay = 0;
		CastTime_Print(CASTTIME_STATUS_DELAY..CASTTIME_OFF);
	else
		CastTime.delay = 1;
		CastTime_Print(CASTTIME_STATUS_DELAY..CASTTIME_ON);
	end
end

function CastTime_Toggle_hun(toggle)
	if (toggle == 0) then
		CastTime.hun = 0;
		CastTime_Print(CASTTIME_STATUS_HUN..CASTTIME_OFF);
	else
		CastTime.hun = 1;
		CastTime_Print(CASTTIME_STATUS_HUN..CASTTIME_ON);
	end
end

function CastTime_Toggle_flock(toggle)
	if (toggle == 0) then
		CastTime.flock = 0;
		CastTimeMF:SetBackdropColor(0, 0.1, 0.9, 0.5);
		CastTimeMF:SetBackdropBorderColor(0, 0.6, 0.8, 0.8);
		local z1, z2;
		if (CastTime.hun == 0) then
			z1=4.5;
			z2=3.2;
		else
			z1=4.53;
			z2=3.29;
		end
		CastTimeMFText:SetText("|cffcc0000+"..z1.."|r "..z2);
		CastTime_Print(CASTTIME_STATUS_FLOCK..CASTTIME_OFF);
	else
		CastTime.flock = 1;
		CastTimeMF:SetBackdropColor(0, 0, 0, 0);
		CastTimeMF:SetBackdropBorderColor(0, 0, 0, 0);
		CastTimeMFText:SetText("");
		CastTime_Print(CASTTIME_STATUS_FLOCK..CASTTIME_ON);
	end
end

function CastTime_Toggle_mf(toggle)
	if (toggle == 0) then
		CastTime.mf = 0;
		CastTimeMF:Hide();
		CastTime_Print(CASTTIME_STATUS_MF..CASTTIME_OFF);
	else
		CastTime.mf = 1;
		CastTimeMF:Show();
		CastTime_Print(CASTTIME_STATUS_MF..CASTTIME_ON);
	end
end

function CastTime_SlashHandler(msg)
	CastTime.print = 1;
	if (not msg) then
		return;
	end
	msg = string.lower(msg);

	local _, _, command, value = string.find (msg, "(%w+) (%w+)");
	if (command == nil) then
		_, _, command = string.find(msg, "(%w+)");
	end

	if (command) then
		if (value == CASTTIME_ON) then
			value = 1;
		elseif (value == CASTTIME_OFF) then
			value = 0;
		else
			CastTime_SlashHandler_PrintStatus(command);
			return;
		end
		if (command == CASTTIME_STAT) then
			CastTime_SlashHandler_PrintStatus();
		elseif (command == CASTTIME_DISPLAY) then
			CastTime_Toggle_display(value);
		elseif (command == CASTTIME_DELAY) then
			CastTime_Toggle_delay(value);
		elseif (command == CASTTIME_HUN) then
			CastTime_Toggle_hun(value);
		elseif (command == CASTTIME_FLOCK) then
			CastTime_Toggle_flock(value);
		elseif (command == CASTTIME_MF) then
			CastTime_Toggle_mf(value);
		end
	else
		CastTime_SlashHandler_help();
	end
	-- sync our vars to cosmos if available - didnt work
--	if (Cosmos_RegisterConfiguration) then
--		Cosmos_UpdateValue("COS_CASSTTIME_DISPLAY_TOGGLE", CSM_CHECKONOFF, CastTime.display);
--		Cosmos_UpdateValue("COS_CASSTTIME_DELAY_TOGGLE", CSM_CHECKONOFF, CastTime.delay);
--		Cosmos_UpdateValue("COS_CASSTTIME_HUN_TOGGLE", CSM_CHECKONOFF, CastTime.hun);
--		CosmosMaster_Save();
--	end
	CastTime.print = 0;
end

function CastTime_SlashHandler_help()
	CastTime_Print(CASTTIME_HELP1);
	CastTime_Print(CASTTIME_HELP2);
	CastTime_Print(CASTTIME_HELP3);
	CastTime_Print(CASTTIME_HELP4);
	CastTime_Print(CASTTIME_HELP5);
	CastTime_Print(CASTTIME_HELP6);
	CastTime_Print(CASTTIME_HELP7);
end

function CastTime_SlashHandler_PrintStatus(command)
	CastTime.print = 1;
	local status;
	if (command == nil) then
		command = CASTTIME_STAT;
	end

	if (command == CASTTIME_DISPLAY or command == CASTTIME_STAT) then
		if (CastTime.display == 1) then
			status = CASTTIME_ON;
		else
			status = CASTTIME_OFF;
		end
		CastTime_Print(CASTTIME_STATUS_DISPLAY..status);
	end
	if (command == CASTTIME_DELAY or command == CASTTIME_STAT) then
		if (CastTime.delay == 1) then
			status = CASTTIME_ON;
		else
			status = CASTTIME_OFF;
		end
		CastTime_Print(CASTTIME_STATUS_DELAY..status);
	end
	if (command == CASTTIME_HUN or command == CASTTIME_STAT) then
		if (CastTime.hun == 1) then
			status = CASTTIME_ON;
		else
			status = CASTTIME_OFF;
		end
		CastTime_Print(CASTTIME_STATUS_HUN..status);
	end
	if (command == CASTTIME_FLOCK or command == CASTTIME_STAT) then
		if (CastTime.flock == 1) then
			status = CASTTIME_ON;
		else
			status = CASTTIME_OFF;
		end
		CastTime_Print(CASTTIME_STATUS_FLOCK..status);
	end
	if (command == CASTTIME_MF or command == CASTTIME_STAT) then
		if (CastTime.mf == 1) then
			status = CASTTIME_ON;
		else
			status = CASTTIME_OFF;
		end
		CastTime_Print(CASTTIME_STATUS_MF..status);
	end
	CastTime.print = 0;
end

function CastTime_Print(msg)
    if (DEFAULT_CHAT_FRAME and CastTime.print == 1) then
        DEFAULT_CHAT_FRAME:AddMessage(msg);
    end
end