-- SheepWatch is orginally based on StunWatch by Vector.
-- First version was released by Veighflo who resigned from developing it
-- after version 1.5.
-- 
-- The actual version got a rewrite in all significant parts by zapi@curse
-- (Asmodean on Turalyon & Ania on Darksorrow)
-- 
-- Thanks:
-- I hereby want to thank the authors of StunWatch, CastTime and MezHelper
-- for some hints I got from their codes.
--
-- Version: 1.6.3
-- Date:		2005-10-12


--------------------------------------------------------
-- Load the whole thing
--------------------------------------------------------
function SheepWatch_OnLoad()
	this:RegisterEvent("CHAT_MSG_SPELL_SELF_DAMAGE");
	this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE");
	this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_DAMAGE");
	this:RegisterEvent("CHAT_MSG_SPELL_AURA_GONE_OTHER");
	this:RegisterEvent("CHAT_MSG_SPELL_BREAK_AURA");
--	this:RegisterEvent("CHAT_MSG_COMBAT_HOSTILE_DEATH");
	this:RegisterEvent("PLAYER_REGEN_ENABLED");
	this:RegisterEvent("PLAYER_DEAD");

	SLASH_SHEEPWATCH1 = "/sheepwatch";
	SLASH_SHEEPWATCH2 = "/sheep";
	SLASH_SHEEPWATCH3 = "/sw";
	SlashCmdList["SHEEPWATCH"] = function(msg)
		SheepWatch_SlashCommandHandler(msg);
	end

	DEFAULT_CHAT_FRAME:AddMessage( SHEEPWATCH_TEXT_LOADED );

end


--------------------------------------------------------
-- Hide the counter frame when loaded.
--------------------------------------------------------
function SheepWatchCounter_OnLoad()
	SheepWatchCounter:Hide();
end


--------------------------------------------------------
-- Handler for /sheepwatch
--------------------------------------------------------
function SheepWatch_SlashCommandHandler(msg)

	local a, b, command , parameter = string.find( msg, "(%w+) (.+)" );

	if( parameter == nil ) then
		command = string.lower( msg );
	end
	
	if( command == nil ) then
		SheepWatch_Help();
	end
		
	if( command == "on" ) then
		if( SHEEPWATCH.STATUS == 0 ) then
			SHEEPWATCH.STATUS = 1;
			SheepWatch_Settings[SHEEPWATCH_PROFILE].status = SHEEPWATCH.STATUS;
			DEFAULT_CHAT_FRAME:AddMessage(SHEEPWATCH_TEXT_ENABLED);
		end
		
	elseif( command == "off" ) then
		if( SHEEPWATCH.STATUS ~= 0 ) then
			SHEEPWATCH.STATUS = 0;
			SheepWatch_Settings[SHEEPWATCH_PROFILE].status = SHEEPWATCH.STATUS;
			DEFAULT_CHAT_FRAME:AddMessage(SHEEPWATCH_TEXT_DISABLED);
		end
		
	elseif( command == "unlock" ) then
		SHEEPWATCH.STATUS = 3;
		SheepWatch:Show();
		DEFAULT_CHAT_FRAME:AddMessage(SHEEPWATCH_TEXT_UNLOCKED);
		
	elseif( command == "lock" ) then
		SHEEPWATCH.STATUS = 1;
		SheepWatch:Hide();
		DEFAULT_CHAT_FRAME:AddMessage(SHEEPWATCH_TEXT_LOCKED);
		
	elseif( command == "clear" ) then
		local pn = UnitName("player");
		if(pn ~= nil and pn ~= UNKNOWNBEING and pn ~= UKNOWNBEING and pn ~= UNKNOWNOBJECT) then
			SheepWatch_ClearProfile();
		else
			DEFAULT_CHAT_FRAME:AddMessage("SheepWatch: " .. SHEEPWATCH_TEXT_WORLD_NOT_LOADED);
		end
		
	elseif( command == "status" ) then
		SheepWatch_PrintStatus();

	elseif( command == "debug" ) then
		SHEEPWATCH.DEBUG = true;
		DEFAULT_CHAT_FRAME:AddMessage("SheepWatch: Debugging enabled for this session.");
	
	elseif( command == "invert" ) then
		SHEEPWATCH.INVERT = not SHEEPWATCH.INVERT;
		if( SHEEPWATCH.INVERT ) then
			DEFAULT_CHAT_FRAME:AddMessage(SHEEPWATCH_TEXT_INVERSION_ON);
		else
			DEFAULT_CHAT_FRAME:AddMessage(SHEEPWATCH_TEXT_INVERSION_OFF);
		end
		SheepWatch_Settings[SHEEPWATCH_PROFILE].invert = SHEEPWATCH.INVERT;
		
	elseif( command == "verbose" ) then
		SHEEPWATCH.VERBOSE = not SHEEPWATCH.VERBOSE;
		if( SHEEPWATCH.VERBOSE ) then
			DEFAULT_CHAT_FRAME:AddMessage(SHEEPWATCH_TEXT_VERBOSE_ON);
		else
			DEFAULT_CHAT_FRAME:AddMessage(SHEEPWATCH_TEXT_VERBOSE_OFF);
		end
		SheepWatch_Settings[SHEEPWATCH_PROFILE].verbose = SHEEPWATCH.VERBOSE;
	
	elseif( command == "counter" ) then
		SHEEPWATCH.COUNTER = not SHEEPWATCH.COUNTER;
		if ( SHEEPWATCH.COUNTER ) then
			DEFAULT_CHAT_FRAME:AddMessage(SHEEPWATCH_TEXT_COUNTER_ON);
		else
			DEFAULT_CHAT_FRAME:AddMessage(SHEEPWATCH_TEXT_COUNTER_OFF);
		end
		SheepWatch_Settings[SHEEPWATCH_PROFILE].counter = SHEEPWATCH.COUNTER;
		
	elseif( command == "announce" ) then
		SHEEPWATCH.ANNOUNCE = not SHEEPWATCH.ANNOUNCE;
		if( SHEEPWATCH.ANNOUNCE ) then
			DEFAULT_CHAT_FRAME:AddMessage(SHEEPWATCH_TEXT_ANNOUNCE_ON);
		else
			DEFAULT_CHAT_FRAME:AddMessage(SHEEPWATCH_TEXT_ANNOUNCE_OFF);
		end
		SheepWatch_Settings[SHEEPWATCH_PROFILE].announce = SHEEPWATCH.ANNOUNCE;
	
	elseif( command == "target" ) then
		if ( parameter ~= nil ) then
			parameter = string.lower( parameter );
			if ( parameter == "say" or parameter == "party" or parameter == "guild" or parameter == "raid") then
				SHEEPWATCH.ANNOUNCE_TARGET = parameter;
				SheepWatch_Settings[SHEEPWATCH_PROFILE].target = SHEEPWATCH.ANNOUNCE_TARGET;
				DEFAULT_CHAT_FRAME:AddMessage( SHEEPWATCH_TEXT_ANNOUNCE_TARGET .. string.upper( SHEEPWATCH.ANNOUNCE_TARGET ) );
			else
				DEFAULT_CHAT_FRAME:AddMessage( SHEEPWATCH_TEXT_ANNOUNCE_NOTARGET );
			end
		end
		
	else
		SheepWatch_Help();
	end
	
end


--------------------------------------------------------
-- Event handler
--------------------------------------------------------
function SheepWatch_OnEvent()
	if( SHEEPWATCH.STATUS == 0 ) then
		return;
	end

	if( event == "CHAT_MSG_SPELL_SELF_DAMAGE" ) then
		local _, _, mobname = string.find(arg1, SHEEPWATCH_EVENT_CAST);
		if( mobname ~= nil and UnitName("target") == mobname) then 
			-- DEBUG
			if( SHEEPWATCH.DEBUG ) then
		 		DEFAULT_CHAT_FRAME:AddMessage("SheepWatch Debug:\nEvent CHAT_MSG_SPELL_SELF_DAMAGE triggered\nArgument: " .. arg1);
			end
			-- END DEBUG
		  if( SHEEPWATCH.VERBOSE ) then
		  	DEFAULT_CHAT_FRAME:AddMessage("SheepWatch: " .. SHEEPWATCH_SPELL .. " (" .. SHEEPWATCH.RANK .. ")" .. SHEEPWATCH_TEXT_ANNOUNCE_CAST .. mobname);
		  end
		  if( SHEEPWATCH.ANNOUNCE ) then
		  	SheepWatch_SendAnnounce(SHEEPWATCH_SPELL .. " (" .. SHEEPWATCH.RANK .. ")" .. SHEEPWATCH_TEXT_ANNOUNCE_CAST .. mobname);
		  end
			if( GetTime() > SHEEPWATCH.TIMER_END + 15 or mobname ~= SHEEPWATCH.MOBNAME ) then
				SHEEPWATCH.DIMINISH = 1;
				if( SHEEPWATCH.DEBUG ) then
					DEFAULT_CHAT_FRAME:AddMessage("SheepWatch Debug: Diminish set to: " .. SHEEPWATCH.DIMINISH);
				end	
			end
			SHEEPWATCH.MOBNAME = mobname;
			SHEEPWATCH.PLAYER = UnitIsPlayer("target");
			SHEEPWATCH.ACTIVE = 1;
			if( SHEEPWATCH.STATUS == 1 ) then
				SheepWatch:Show(); 
			else
				SheepWatch_OnShow();
			end
		end
	elseif( event == "CHAT_MSG_SPELL_BREAK_AURA" ) then
		local currentTime = GetTime();
		local  _, _, mobname = string.find(arg1, SHEEPWATCH_EVENT_BREAK);
		if( mobname ~= nil and mobname == SHEEPWATCH.MOBNAME ) then
			-- DEBUG
			if( SHEEPWATCH.DEBUG ) then
		 		DEFAULT_CHAT_FRAME:AddMessage("SheepWatch Debug:\nEvent CHAT_MSG_SPELL_BREAK_AURA triggered\nArgument: " .. arg1);
			end
			-- END DEBUG
		  if( SHEEPWATCH.VERBOSE ) then
		  	DEFAULT_CHAT_FRAME:AddMessage("SheepWatch: " .. SHEEPWATCH_TEXT_ANNOUNCE_BREAK  .. mobname);
		  end
			SHEEPWATCH.TIMER_END = currentTime;
			if( SHEEPWATCH.PLAYER ) then
				SHEEPWATCH.DIMINISH = SHEEPWATCH.DIMINISH * 2;
				if( SHEEPWATCH.DEBUG ) then
					DEFAULT_CHAT_FRAME:AddMessage("SheepWatch Debug: Diminish set to: " .. SHEEPWATCH.DIMINISH);
				end	
			end
			if( SHEEPWATCH.ACTIVE == 1 ) then
				SHEEPWATCH.ACTIVE = 0;
			end
		end
	elseif( event == "CHAT_MSG_SPELL_AURA_GONE_OTHER" ) then
		local currentTime = GetTime();
		local  _, _, mobname = string.find(arg1, SHEEPWATCH_EVENT_FADE);
		if( mobname ~= nil and mobname == SHEEPWATCH.MOBNAME ) then
			-- DEBUG
			if( SHEEPWATCH.DEBUG ) then
		 		DEFAULT_CHAT_FRAME:AddMessage("SheepWatch Debug:\nEvent CHAT_MSG_SPELL_AURA_GONE_OTHER triggered\nArgument: " .. arg1);
			end
			-- END DEBUG
		  if( SHEEPWATCH.VERBOSE ) then
		  	DEFAULT_CHAT_FRAME:AddMessage("SheepWatch: " .. SHEEPWATCH_TEXT_ANNOUNCE_FADE .. mobname);
		  end
		  SHEEPWATCH.TIMER_END = currentTime;
		  if( SHEEPWATCH.PLAYER ) then
				SHEEPWATCH.DIMINISH = SHEEPWATCH.DIMINISH * 2;
				if( SHEEPWATCH.DEBUG ) then
					DEFAULT_CHAT_FRAME:AddMessage("SheepWatch Debug: Diminish set to: " .. SHEEPWATCH.DIMINISH);
				end	
			end
			if( SHEEPWATCH.ACTIVE == 1 ) then
				SHEEPWATCH.ACTIVE = 0;
			end
		end
	elseif( event == "PLAYER_REGEN_ENABLED" or event == "PLAYER_DEAD" ) then
		-- DEBUG
		if( SHEEPWATCH.DEBUG ) then
			DEFAULT_CHAT_FRAME:AddMessage("SheepWatch Debug:\nEvent PLAYER_REGEN_ENABLED or PLAYER_DEAD triggered");
		end
		-- END DEBUG
		if( SHEEPWATCH.ACTIVE == 1 ) then
			SHEEPWATCH.ACTIVE = 0;
			SHEEPWATCH.TIMER_END = GetTime();
		  if( SHEEPWATCH.VERBOSE ) then
		  	DEFAULT_CHAT_FRAME:AddMessage( SHEEPWATCH_TEXT_ANNOUNCE_LEAVECOMBAT );
		  end			
		end
	end
end


--------------------------------------------------------
-- Shows the statusbar
--------------------------------------------------------
function SheepWatch_OnShow()
	local isPlayer = ""
	local Status = GetTime()

	if( SHEEPWATCH.ACTIVE ~= 0 ) then
		SHEEPWATCH.TIMER_START = Status;
		if( SHEEPWATCH.PLAYER ) then
			SHEEPWATCH.TIMER_END = SHEEPWATCH.TIMER_START + (SHEEPWATCH.PVPLENGTH / SHEEPWATCH.DIMINISH);
		else
			SHEEPWATCH.TIMER_END = SHEEPWATCH.TIMER_START + (SHEEPWATCH.LENGTH / SHEEPWATCH.DIMINISH);
		end
		if( SHEEPWATCH.DEBUG ) then
			if ( SHEEPWATCH.PLAYER ) then isPlayer="Yes" else isPlayer="No" end
			DEFAULT_CHAT_FRAME:AddMessage("SheepWatch Debug:\nPlayer: "..isPlayer.."\nStart: "..SHEEPWATCH.TIMER_START.."\nLength: "..SHEEPWATCH.LENGTH.."\nEnd: "..SHEEPWATCH.TIMER_END);
		end
	end
	if( SHEEPWATCH.STATUS ~= 3 ) then
		SHEEPWATCH.STATUS = 2;
	end
	this:SetAlpha(1);
	SheepWatchFrameStatusBar:SetStatusBarColor(1, 1, 0);
	SheepWatchSpark:SetPoint("CENTER", "SheepWatchFrameStatusBar", "LEFT", 0, 0);
	SheepWatchText:SetText( SHEEPWATCH_SPELL );

	if( SHEEPWATCH.COUNTER ) then
		SheepWatchCounter:Show();
	end

end


--------------------------------------------------------
-- Update handler
--------------------------------------------------------
function SheepWatch_OnUpdate()
	if( SHEEPWATCH.STATUS == 3 ) then
		return;
	end

	local Status = GetTime();
	local Elapsed = SHEEPWATCH.TIMER_END - Status;
	
	local subto = 4;
	if (Elapsed < 10) then
		subto = 3;
	end
	
	local seconds = string.sub(math.max(Elapsed,0)+0.001, 1, subto);
	
	if( SHEEPWATCH.ACTIVE > 0 and Status < SHEEPWATCH.TIMER_END ) then
		SheepWatchFrameStatusBar:SetMinMaxValues(SHEEPWATCH.TIMER_START, SHEEPWATCH.TIMER_END);
		if( SHEEPWATCH.COUNTER ) then
			SheepWatchCounterText:SetText( seconds );
		end
		local sparkPosition = ((Status - SHEEPWATCH.TIMER_START) / (SHEEPWATCH.TIMER_END - SHEEPWATCH.TIMER_START)) * 195;
		if( SHEEPWATCH.INVERT )then
			sparkPosition = 195 - sparkPosition;
			SheepWatchFrameStatusBar:SetValue(SHEEPWATCH.TIMER_START + SHEEPWATCH.TIMER_END - Status);
		else
			SheepWatchFrameStatusBar:SetValue(Status);
		end
		if( sparkPosition < 1 ) then
			sparkPosition = 1;
		end
		SheepWatchSpark:SetPoint("CENTER", "SheepWatchFrameStatusBar", "LEFT", sparkPosition, 0);
	elseif( this:GetAlpha() > 0 ) then
		if( SHEEPWATCH.STATUS == 2 ) then
			SHEEPWATCH.STATUS = 1;
			SHEEPWATCH.ACTIVE = 0;
			SheepWatchText:SetText("Timeout");
		end
		local alpha = this:GetAlpha() - SHEEPWATCH.ALPHA_STEP;
		if( alpha > 0 ) then
			this:SetAlpha(alpha);
		else
			this.fadeOut = nil;
			this:Hide();
			SheepWatchCounter:Hide();
		end
	else
		this:Hide();
		SHEEPWATCH.STATUS = 1;
		SHEEPWATCH.ACTIVE = 0;
		SHEEPWATCH.MOBNAME = "";
		SHEEPWATCH.PLAYER = nil;
	end

end


--------------------------------------------------------
-- Check if a target is polymorhped.
--------------------------------------------------------
function isPolymorphed( unit ) 
  local i = 1;
  local debuff;

  if ( UnitIsDead("target") or UnitIsCorpse("target") ) then
  	return false
 	else
   	while ( UnitDebuff( unit, i ) ) do
 			if( SHEEPWATCH.DEBUG ) then
				DEFAULT_CHAT_FRAME:AddMessage("SheepWatch Debug: " .. unit .. " is debuffed with: " .. UnitDebuff( unit, i ));
			end
			if( string.find( UnitDebuff( unit, i ), SHEEPWATCH.DEBUFF ) ) then
				return true
    	end
    	i = i + 1;
  	end
  	return false
  end

end

--------------------------------------------------------
-- Helper function to be called from macros for debugging
-- (no direct call from the script)
--------------------------------------------------------
function showAllUnitDebuffs(unit) 
  local i = 1
  while (UnitDebuff(unit, i)) do
    DEFAULT_CHAT_FRAME:AddMessage(UnitDebuff(unit, i));
    i = i + 1;
  end
end

--------------------------------------------------------
-- Polymorphs the current target with your highest rank
--------------------------------------------------------
function SheepWatch_SheepTarget()
	if( SheepWatch_ReTargetMob() ) then
		CastSpellByName( SHEEPWATCH_SPELL .. "(" .. SHEEPWATCH.RANK .. ")");
	else
		DEFAULT_CHAT_FRAME:AddMessage( SHEEPWATCH_TEXT_ANNOUNCE_TARGETFAILED );
	end
end

--------------------------------------------------------
-- Tries to retargets our sheep when clicked on progessbar
--------------------------------------------------------
function SheepWatch_ReTargetMob()
	local i
	local foundSheep = false
	-- Atfirst the obvisious ones..
	TargetLastEnemy();
	if ( isPolymorphed("target") ) then
		foundSheep = true;
	else
		TargetByName(SHEEPWATCH.MOBNAME);
		if ( isPolymorphed("target") ) then
			foundSheep = true;
		else 
		-- Let's cycle a bit (but not until Harry Potter 7 arrives in the stores :).
			for i=1,20 do
				if( SHEEPWATCH.DEBUG ) then
					DEFAULT_CHAT_FRAME:AddMessage("SheepWatch Debug: ReTargetMob Cycle: " .. i);
				end
				TargetNearestEnemy();
				if ( isPolymorphed("target") ) then
					if( SHEEPWATCH.DEBUG ) then
						DEFAULT_CHAT_FRAME:AddMessage("SheepWatch Debug: Found Sheep");
					end
					foundSheep = true;
					break
				end
			end
		end	
	end
	if( foundSheep ) then 
		if( SHEEPWATCH.VERBOSE ) then
		 	DEFAULT_CHAT_FRAME:AddMessage( SHEEPWATCH_TEXT_ANNOUNCE_TARGETSUCCESS );
		end
		return true
	else
		if( SHEEPWATCH.VERBOSE ) then
		 	DEFAULT_CHAT_FRAME:AddMessage( SHEEPWATCH_TEXT_ANNOUNCE_TARGETFAILED );
		end
		return false
	end
end


--------------------------------------------------------
-- Get the highest rank of Polymorph spell
--------------------------------------------------------
local function SheepWatch_GetSpellRank(spell)
	local rank = 0;
	for i = 1, 180 do 
		local spellName, spellRank = GetSpellName(i, BOOKTYPE_SPELL);

		if( spellName ) then
			if( string.find(spellName, spell, 1, true) ) then
				rank = spellRank;
			end    	                
	            
		end
 	end
  return rank;
end


--------------------------------------------------------
-- Set SHEEPWATCH.LENGTH based on the highest spell rank
--------------------------------------------------------
function SheepWatch_SetTimerLength()
	
	local rank = SheepWatch_GetSpellRank( SHEEPWATCH_SPELL );
	local _, _, _, ranknumber = string.find( rank, "(.+) (.+)" );
	SHEEPWATCH.RANK = rank;

	if( ranknumber ) then
		DEFAULT_CHAT_FRAME:AddMessage("SheepWatch: " .. SHEEPWATCH.RANK .. SHEEPWATCH_TEXT_RANK);
		if( ranknumber == "1" ) then
			SHEEPWATCH.LENGTH = 20.0;
		elseif( ranknumber == "2" ) then
			SHEEPWATCH.LENGTH = 30.0;
		elseif( ranknumber == "3" ) then
			SHEEPWATCH.LENGTH = 40.0;
		elseif( ranknumber == "4" ) then
			SHEEPWATCH.LENGTH = 50.0;
	end
	else
		-- If we don't get a rank, we disable ourself.
		DEFAULT_CHAT_FRAME:AddMessage(SHEEPWATCH_TEXT_NORANK);
		SHEEPWATCH.STATUS = 0;
		DEFAULT_CHAT_FRAME:AddMessage(SHEEPWATCH_TEXT_DISABLED);
	end		
end


--------------------------------------------------------
-- Sends a message to the target defined by "/sheepwatch target"
--------------------------------------------------------
function SheepWatch_SendAnnounce( msg )
	local chan = SHEEPWATCH.ANNOUNCE_TARGET

	if ( chan == "say" ) then
		SendChatMessage(msg, "SAY");
	elseif ( chan == "party" ) then
		if ( GetNumPartyMembers() > 0 ) then
			SendChatMessage( msg, "PARTY" );
		end
	elseif ( chan == "guild" ) then
		if ( IsInGuild() ) then
			SendChatMessage( msg, "GUILD" );
		end
	elseif ( chan == "raid" ) then
		if ( GetNumRaidMembers() > 0 ) then
			SendChatMessage( msg, "RAID" );
		end
	else
		DEFAULT_CHAT_FRAME:AddMessage(SHEEPWATCH_TEXT_ANNOUNCE_NOTARGET);
	end

end


--------------------------------------------------------
-- Load the variables.
--------------------------------------------------------
function SheepWatch_LoadVariables(arg1)
	if SHEEPWATCH_VARIABLES_LOADED then
		return
	end
	
	-- Get the actual Polymorph rank
	SheepWatch_SetTimerLength();
	
	-- Disable debugging by default
	SHEEPWATCH.DEBUG = false;

	local playerName
	local playerName=UnitName("player")
	if playerName==nil or playerName==UNKNOWNBEING or playerName==UKNOWNBEING or playerName==UNKNOWNOBJECT then
		return
	end

	SHEEPWATCH_PROFILE = playerName.." of "..GetCVar("RealmName");

	-- Apply default settings to the profile if the aren't set yet
	-- Default settings are defined in SheepWatch_Globals.lua
	if( SheepWatch_Settings[SHEEPWATCH_PROFILE] == nil ) then
		SheepWatch_Settings[SHEEPWATCH_PROFILE] = { };
		SheepWatch_Settings[SHEEPWATCH_PROFILE].version = SHEEPWATCH_VERSION;
	else
		SheepWatch_CheckProfile( SHEEPWATCH_PROFILE );
	end

	if( SheepWatch_Settings[SHEEPWATCH_PROFILE].status == nil ) then
		SheepWatch_Settings[SHEEPWATCH_PROFILE].status = SHEEPWATCH.STATUS;
	end

	if( SheepWatch_Settings[SHEEPWATCH_PROFILE].invert == nil ) then
		SheepWatch_Settings[SHEEPWATCH_PROFILE].invert = SHEEPWATCH.INVERT;
	end

	if( SheepWatch_Settings[SHEEPWATCH_PROFILE].verbose == nil ) then
		SheepWatch_Settings[SHEEPWATCH_PROFILE].verbose = SHEEPWATCH.VERBOSE;
	end	

	if( SheepWatch_Settings[SHEEPWATCH_PROFILE].counter == nil ) then
		SheepWatch_Settings[SHEEPWATCH_PROFILE].counter = SHEEPWATCH.COUNTER;
	end	

	if (SheepWatch_Settings[SHEEPWATCH_PROFILE].announce == nil )then
		SheepWatch_Settings[SHEEPWATCH_PROFILE].announce = SHEEPWATCH.ANNOUNCE;
	end	

	if (SheepWatch_Settings[SHEEPWATCH_PROFILE].target == nil ) then
		SheepWatch_Settings[SHEEPWATCH_PROFILE].target = SHEEPWATCH.ANNOUNCE_TARGET;
	end	
	
	-- Read settings from the profile
	SHEEPWATCH.STATUS = SheepWatch_Settings[SHEEPWATCH_PROFILE].status;
	SHEEPWATCH.INVERT = SheepWatch_Settings[SHEEPWATCH_PROFILE].invert;
	SHEEPWATCH.VERBOSE = SheepWatch_Settings[SHEEPWATCH_PROFILE].verbose;
	SHEEPWATCH.COUNTER = SheepWatch_Settings[SHEEPWATCH_PROFILE].counter;
	SHEEPWATCH.ANNOUNCE = SheepWatch_Settings[SHEEPWATCH_PROFILE].announce;
	SHEEPWATCH.ANNOUNCE_TARGET = SheepWatch_Settings[SHEEPWATCH_PROFILE].target;
	
	SHEEPWATCH_VARIABLES_LOADED = true
	SheepWatch_Variable_Frame:Hide();

end


--------------------------------------------------------
-- Print the internal variables for debugging purposes.
--------------------------------------------------------
function SheepWatch_PrintStatus()

	DEFAULT_CHAT_FRAME:AddMessage("Profile: " .. SHEEPWATCH_PROFILE);
	DEFAULT_CHAT_FRAME:AddMessage("Status: " .. SHEEPWATCH.STATUS);
	DEFAULT_CHAT_FRAME:AddMessage("Spell: " .. SHEEPWATCH_SPELL);
	DEFAULT_CHAT_FRAME:AddMessage("Rank: " .. SHEEPWATCH.RANK);	
	DEFAULT_CHAT_FRAME:AddMessage("Length: " .. SHEEPWATCH.LENGTH);
	if( SHEEPWATCH.VERBOSE ) then
		DEFAULT_CHAT_FRAME:AddMessage("Verbose: On");
	else
		DEFAULT_CHAT_FRAME:AddMessage("Verbose: Off");
	end
	if( SHEEPWATCH.INVERT ) then
		DEFAULT_CHAT_FRAME:AddMessage("Invert: On");
	else
		DEFAULT_CHAT_FRAME:AddMessage("Invert: Off");
	end
	if( SHEEPWATCH.COUNTER ) then
		DEFAULT_CHAT_FRAME:AddMessage("Counter: On");
	else
		DEFAULT_CHAT_FRAME:AddMessage("Counter: Off");
	end
	if( SHEEPWATCH.ANNOUNCE ) then
		DEFAULT_CHAT_FRAME:AddMessage("Announce: On");
	else
		DEFAULT_CHAT_FRAME:AddMessage("Announce: Off");
	end
	DEFAULT_CHAT_FRAME:AddMessage("Target: " .. SHEEPWATCH.ANNOUNCE_TARGET);

end


--------------------------------------------------------
-- Check if user's profile need to be cleared
--------------------------------------------------------
function SheepWatch_CheckProfile(profile)
	local profileversion = nil;
	local version = SHEEPWATCH_VERSION;
	
	if( SheepWatch_Settings[profile].version ~= nil ) then
		-- Get the actual version in the profile when already set.
		profileversion = SheepWatch_Settings[profile].version;
	end
	
	if( profileversion == nil and SHEEPWATCH.CLEAR == 1 ) then
		-- Clear when we are asked to do so and no version was set yet.
		SheepWatch_ClearProfile();
		SheepWatch_Settings[profile].version = version;
		DEFAULT_CHAT_FRAME:AddMessage( SHEEPWATCH_TEXT_PROFILECLEARED );
	elseif( version ~= profileversion and SHEEPWATCH.CLEAR ) then
		-- Clear because we are asked to do so.
		SheepWatch_ClearProfile();
		SheepWatch_Settings[profile].version = version;
		DEFAULT_CHAT_FRAME:AddMessage( SHEEPWATCH_TEXT_PROFILECLEARED );
	end	 

end


--------------------------------------------------------
-- Clear user's profile from SavedVariables.lua
--------------------------------------------------------
function SheepWatch_ClearProfile()
	local pn = UnitName("player");
	local SHEEPWATCH_PROFILE = pn .. " of " .. GetCVar("RealmName");

	SheepWatch_Settings[SHEEPWATCH_PROFILE] = nil;
	SHEEPWATCH_VARIABLES_LOADED = false;
	SheepWatch_LoadVariables(2);
end


--------------------------------------------------------
-- Print the help
--------------------------------------------------------
function SheepWatch_Help()
	DEFAULT_CHAT_FRAME:AddMessage("SheepWatch " .. SHEEPWATCH_VERSION .. SHEEPWATCH_HELP1);
	DEFAULT_CHAT_FRAME:AddMessage(SHEEPWATCH_HELP2);
	DEFAULT_CHAT_FRAME:AddMessage(SHEEPWATCH_HELP3);
	DEFAULT_CHAT_FRAME:AddMessage(SHEEPWATCH_HELP4);
	DEFAULT_CHAT_FRAME:AddMessage(SHEEPWATCH_HELP5);
	DEFAULT_CHAT_FRAME:AddMessage(SHEEPWATCH_HELP6);
	DEFAULT_CHAT_FRAME:AddMessage(SHEEPWATCH_HELP7);
	DEFAULT_CHAT_FRAME:AddMessage(SHEEPWATCH_HELP8);
	DEFAULT_CHAT_FRAME:AddMessage(SHEEPWATCH_HELP9);
	DEFAULT_CHAT_FRAME:AddMessage(SHEEPWATCH_HELP10);
	DEFAULT_CHAT_FRAME:AddMessage(SHEEPWATCH_HELP11);
end




